#!/bin/bash
# /home/david/SyncthingFolders/allScripts/YPlayer/YadPlayerTabs2.sh
#########################################################################
# required: yad bash(v4+) mplayer imagemagick xdg-open wmctrl xdotool   #
#            ffmpeg														#
#########################################################################
# this script written by Dave Parker and a lot of google-Copy-Pasting
# license:  free to use, please send me a link of improvements to me
#    at:  cedardocster AT gmail DOT com
#  Warning! this will resize album art it finds to a more appropriate 
#    size - sorry - its at line 103: "mogrify" (won't do it if you don't
#    have imagemagick)
# huge comments are from http://patorjk.com/software/taag/#p=display&h=2&v=0&c=bash&f=Univers&t=while

startinglist="$@"
export recent=0
#                                                                        
#             ad88888ba                                                  
#            d8"     "8b                ,d                               
#            Y8,                        88                               
#            `Y8aaaaa,     ,adPPYba,  MM88MMM  88       88  8b,dPPYba,   
#              `"""""8b,  a8P_____88    88     88       88  88P'    "8a  
#                    `8b  8PP"""""""    88     88       88  88       d8  
#            Y8a     a8P  "8b,   ,aa    88,    "8a,   ,a88  88b,   ,a8"  
#             "Y88888P"    `"Ybbd8"'    "Y888   `"YbbdP'Y8  88`YbbdP"'   
#                                                           88           
#                                                           88           

export SCRIPTPATH=$(realpath $0);# should give the name of the script
echo $SCRIPTPATH > ~/.scriptpath
#export SCRIPTFOLDER="/home/david/SyncthingFolders/allScripts/YadPlayer"
#yad --text="startinglist is =$startinglist=" --center
pkill mplayer &
killpid=$(cat /tmp/killpid)
sleep .3
kill "$killpid" &
> /tmp/killpid &

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function close () {
ID=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Yad Player')
pkill mplayer
xdotool windowclose $ID
sleep 1 && pkill mplayer
wmctrl -c "Pick a List to Play" &
ID=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Track Info')
xdotool windowclose $ID
}
export -f close
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function search () {
wmctrl -c "Track Info" 
bash "${SCRIPTFOLDER}/songSearch.sh" &
}
export -f search
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF


close 
> /tmp/ypNotes.txt

# test if wmctrl exists
wmctrlTest=$(command -v wmctrl);
if test -z "$wmctrlTest" 
then
    yad --text="you don't seem to have wmctrl installed.
  Install it and try again
  try something like:
  sudo apt install wmctrl" &
  exit
    else
  echo wmctrl exists
fi

# test if xdotool exists
xdotoolTest=$(command -v xdotool);
if test -z "$xdotoolTest" 
then
    yad --text="you don't seem to have xdotool installed.
  Install it and try again
  try something like:
  sudo apt install xdotool" &
  exit
    else
  echo xdotool exists
fi

# test if imagemagick exists
imagemagickTest=$(dpkg -s imagemagick);
if test -z "$imagemagickTest" 
then
    yad --text="you don't seem to have imagemagick installed.
  The script will run, but the Art resizing might not work right" --timeout=3 &
  
    else
  echo imagemagick exists
fi

# test if mplayer exists
mplayertest=$((hash mplayer) 2>&1)
if [[ $mplayertest == *"not found"* ]]; then
  yad --text="you don't seem to have mplayer installed.
  Install it and try again"
  exit
  else
  echo mplayer exists
fi



#test if mplayerlog exists: 
if [ -f /tmp/mplayerlog ] 
then
echo /tmp/mplayerlog exists!
else
    touch /tmp/mplayerlog
    echo just made your /tmp/mplayerlog
fi

#test if todaysList exists: 
if [ -f /tmp/todaysList ] 
then
echo /tmp/todaysList exists!
else
    touch /tmp/todaysList
    echo just made your /tmp/todaysList
fi


#test if mplayer control pipe exists: /home/david/.mplayer/fifo
if [ -p /home/david/.mplayer/fifo ] 
then
echo /home/david/.mplayer/fifo exists!
else
	rm ~/.mplayer/fifo
    mkfifo ~/.mplayer/fifo
    echo just made your fifo pipe
fi


#test if ~/.mplayer/config has reference to fifo pipe
homepath=$(eval echo "~$USER")
configtest=$(cat ${homepath}/.mplayer/config)
if [[ $configtest == *"fifo"* ]]; then
  echo you should be good to go
  else
  echo you need to edit the .mplayer config
  echo input=file=${homepath}/.mplayer/fifo > ${homepath}/.mplayer/config
fi


#test if musicpath exists: 
if [ -f ~/.musicpath ] 
then
export musicpath=$(cat ~/.musicpath)
else
MYOUT=$(yad --title="pick Music location" --form --field="pick Music folder:DIR" "${homepath}/Music")
var=$?;echo $var; [[ $var = "1" ]] && echo cancelled && yad --text="sorry, you have to pick a music folder...
closing now" --timeout=2 && exit
echo $MYOUT | sed 's/|//' > ~/.musicpath
export musicpath=$(echo $MYOUT | sed 's/|//')
fi

# This to generate recent music files but only once per boot cycle
cd $musicpath
if [ -f /tmp/recent ] 
then
break
else
find -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) -printf '%T@ %c %p\n' | sort -r -k 1 -n | tr -s ' ' | cut -d' ' -f7- | sed 's/\.\///' | head -n 300 > 0.recentSongs.m3u &
touch /tmp/recent
fi


#test if scriptfolder exists: 
if [ -f ~/.scriptfolder ] 
then
export SCRIPTFOLDER=$(cat ~/.scriptfolder)
else
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
MYOUT=$(yad --title="pick location this script lives" --form --field="pick script folder:DIR" "$DIR")
var=$?;echo $var; [[ $var = "1" ]] && echo cancelled && yad --text="sorry, you have to pick a music folder...
closing now" --timeout=2 && exit
echo $MYOUT | sed 's/|//' > ~/.scriptfolder
export scriptfolder=$(echo $MYOUT | sed 's/|//')
export SCRIPTFOLDER="$scriptfolder"
fi


###################################################################
###################################################################




#                                                                                                                          
#     ad88                 ad88888ba   88                                                     88           88              
#    d8"                  d8"     "8b  88                                              ,d     ""    ,d     88              
#    88                   Y8,          88                                              88           88     88              
#  MM88MMM  888           `Y8aaaaa,    88,dPPYba,    ,adPPYba,   8b      db      d8  MM88MMM  88  MM88MMM  88   ,adPPYba,  
#    88     888             `"""""8b,  88P'    "8a  a8"     "8a  `8b    d88b    d8'    88     88    88     88  a8P_____88  
#    88                           `8b  88       88  8b       d8   `8b  d8'`8b  d8'     88     88    88     88  8PP"""""""  
#    88     888           Y8a     a8P  88       88  "8a,   ,a8"    `8bd8'  `8bd8'      88,    88    88,    88  "8b,   ,aa  
#    88     888            "Y88888P"   88       88   `"YbbdP"'       YP      YP        "Y888  88    "Y888  88   `"Ybbd8"'  
#                                                                                                                          
#                                                                                                                          

#######################################################################
#declare -pf trackinfo; # was supposed to allow external use of the function, didnt work
function trackinfo () {



	KEY=$RANDOM
echo line 206
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)

durpath="${musicpath}/${mpath}"
durpath2=$(echo $durpath | sed 's/\/ /\//');durpath=$durpath2;#yad --text="=$durpath="
myCMD=$(ffmpeg as ffmpeg -i """${durpath}""" 2>&1 | grep Duration);#yad --text="=$myCMD="

duration=$(echo "$myCMD" | awk '{print $2}' | sed 's/,//')

mpath2=$(echo ${mpath# $musicpath})
mpath=$mpath2
echo $mpath | sed 's/\.\///' >> /tmp/todaysList
IFS=/ read -a foo <<< $mpath
artist="${foo[0]}"
album="${foo[1]}"
song="${foo[2]}"
export artpath="""${musicpath}/${artist}/${album}"""
cd """${artpath}"""
artpic="""$artpath/$(cd "$artpath";find . -maxdepth 1 \( -iname "*.png" -o -iname "*.jpg" -o -iname "*.jpeg" \) -printf "%p\n" | sort | head -1 | sed 's/\.\///')"""
#yad --text="$artpath =$artpic=" &
#filesize=$(stat --printf="%s" "${artpic}")
#[[ $filesize -gt 50000 ]] && mogrify -resize 250x250 "${artpic}" && yad --text="mogrified" --timeout=3 &
myart="1"
#xdg-open "$artpic" &

identify "${artpic}" | grep -qi "250x" && myart="0"
identify "${artpic}" | grep -qi "x250" && myart="0"
[[ $myart == "1" ]] && mogrify -resize 300x300 "${artpic}" && yad --text="mogrified" --timeout=3 &


if [[ "$artpic" != *".png"* ]] && [[ "$artpic" != *".jpg"* ]] && [[ "$artpic" != *".jpeg"* ]] 
then  
xdg-open "https://www.google.com/search?q=album+art+%22${artist}%22+%22${album}%22&tbas=0&tbm=isch&sxsrf=ACYBGNQGQQ35WcRCLbwrQgTtbC0c9DnQaA:1579928879705&source=lnt&tbs=isz:l&sa=X&ved=0ahUKEwibqZTd_Z3nAhXBLH0KHcOfCc0QpwUIJA&biw=1512&bih=912&dpr=1" &
yad --text="When you've downloaded the image $album to home/\(user\)/Downloads (okay to keep original filename), click ok" --on-top --center
output=`echo $?`
[[ $output = "1" ]] && exit
cd ~/Downloads
newfile=$(ls -Art | tail -n 1)
#yad --text="=$newfile="
mogrify -resize 250x250 ${newfile}
sleep 1
CMD="mv ~/Downloads/${newfile} \"${artpath}\"/"
echo -n "$CMD" | xclip -selection clipboard
#yad --text="$CMD"
eval $CMD
sleep 1
artpic="""${artpath}/${newfile}"""

fi	
	cd "$musicpath"
	alllists="$(ls *.m3u)"
	playlists="";foundlists=""
	ls *.m3u > /tmp/alllists
	##### grep current song from playlists:
	ls -d $PWD/*.m3u > /tmp/alllists
		foundlists=$(cat /tmp/alllists | while read i; do grep -il "$song" "$i"; done)
	###### end grep current song from playlists:

	[[ $foundlists != "" ]] && playlists=" 
this song is on the following lists:
	
$foundlists"
	#echo playlists =$alllists=

#                                                                                              
#  888888888888         88                  88                 db                              
#       88              88                ,d88                d88b                      ,d     
#       88              88              888888               d8'`8b                     88     
#       88  ,adPPYYba,  88,dPPYba,          88  888         d8'  `8b      8b,dPPYba,  MM88MMM  
#       88  ""     `Y8  88P'    "8a         88  888        d8YaaaaY8b     88P'   "Y8    88     
#       88  ,adPPPPP88  88       d8         88            d8""""""""8b    88            88     
#       88  88,    ,88  88b,   ,a8"         88  888      d8'        `8b   88            88,    
#       88  `"8bbdP"Y8  8Y"Ybbd8"'          88  888     d8'          `8b  88            "Y888  
#                                                                                              
#                                                                                              

	# comment out any amphersands
	artist2=$(echo $artist | sed "s/\&/\&amp;/g")
	album2=$(echo $album | sed "s/\&/\&amp;/g")
	song2=$(echo $song | sed "s/\&/\&amp;/g")	
	export currentsong=$song2
	listnumber=$(wc -l "$musicpath/${currentList}.m3u" | head -n1 | cut -d " " -f1)
	
yad --title="Track Info" --wrap --plug=$KEY --tabnum=1 --list --column=":img" --column="$currentList - $listnumber songs" "${artpic}" "

	Artist: '$artist2'
	Album: '$album2'
	Song: '$song2'
	Duration: '$duration'
	
	$playlists" &
    




#                                                                                                            
#  888888888888         88               ad888888b,          88           88                                 
#       88              88              d8"     "88          88           ""               ,d                
#       88              88                      a8P          88                            88                
#       88  ,adPPYYba,  88,dPPYba,           ,d8P"   888     88           88  ,adPPYba,  MM88MMM  ,adPPYba,  
#       88  ""     `Y8  88P'    "8a        a8P"      888     88           88  I8[    ""    88     I8[    ""  
#       88  ,adPPPPP88  88       d8      a8P'                88           88   `"Y8ba,     88      `"Y8ba,   
#       88  88,    ,88  88b,   ,a8"     d8"          888     88           88  aa    ]8I    88,    aa    ]8I  
#       88  `"8bbdP"Y8  8Y"Ybbd8"'      88888888888  888     88888888888  88  `"YbbdP"'    "Y888  `"YbbdP"'  
#                                                                                                            
#                                                                                                            
               

################################### Toggle playlist tab ######################
echo playlist page
	cd "$musicpath"
	CMD1="yad --text=\"Toggle Playlists for *** $currentsong ***\" --plug=$KEY --tabnum=2 --form --columns=4 "
	CMD2=""
	CMD3=""

	aLists=()
while IFS= read -r line; do
    aLists+=( "$line" )
done < <( ls *.m3u )

	numitems=$(echo "${#aLists[@]}")
		
	# fffffffffffffffffffffffffffffffffffffffffffff
	# fffffffffffffffffffffffffffffffffffffffffffff	
	function onClick () {
plist=$(echo "$@")
#yad --text="the playlist is =$plist="
	song=$(cat /tmp/todaysList | sed 's/\.\///' | tail -1);song2=$(echo $song | sed "s/\&/\&amp;/g")
	#yad --text="the song is =$song2="
	test=$(grep -o "$song" "${musicpath}/${plist}")
	#echo "$CMD" | yad --text-info --editable
	#wmctrl -c "Track Info"
if [ -z "$test" ]
then
    yad --text="adding *${song2}* to *$plist*" --timeout=1 --geometry=800x100+400+20 &
    echo ${musicpath}/${song}  | cut -d "/" -f5- >> "${plist}"
    
else
    yad --text="taking off playlist =${musicpath}/${song2}=" --timeout=1 --geometry=800x100+400+20 &
    justsong=$(basename "${musicpath}/${song}")
    #sed -i "/\bexample\b/d" myfile
    CMD="sed -i \"/\b${justsong}\b/d\" \"${musicpath}/${plist}\""
    #echo $CMD | yad --text-info --center
    eval "$CMD"
fi
	
}
export -f onClick
	# fffffffffffffffffffffffffffffffffffffffffffff
	# fffffffffffffffffffffffffffffffffffffffffffff


#                                                                                                                                                     
#  888888888888         88               ad888888b,            ,ad8888ba,                                                              88             
#       88              88              d8"     "88           d8"'    `"8b                             ,d                              88             
#       88              88                      a8P          d8'                                       88                              88             
#       88  ,adPPYYba,  88,dPPYba,           aad8"   888     88              ,adPPYba,   8b,dPPYba,  MM88MMM  8b,dPPYba,   ,adPPYba,   88  ,adPPYba,  
#       88  ""     `Y8  88P'    "8a          ""Y8,   888     88             a8"     "8a  88P'   `"8a   88     88P'   "Y8  a8"     "8a  88  I8[    ""  
#       88  ,adPPPPP88  88       d8             "8b          Y8,            8b       d8  88       88   88     88          8b       d8  88   `"Y8ba,   
#       88  88,    ,88  88b,   ,a8"     Y8,     a88  888      Y8a.    .a8P  "8a,   ,a8"  88       88   88,    88          "8a,   ,a8"  88  aa    ]8I  
#       88  `"8bbdP"Y8  8Y"Ybbd8"'       "Y888888P'  888       `"Y8888Y"'    `"YbbdP"'   88       88   "Y888  88           `"YbbdP"'   88  `"YbbdP"'  
#                                                                                                                                                     
#                                                                                                                                                     
               
#  Below is the Controls tab functions
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function addnewplaylist () {
	EXT="mp3"
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
[[ $mpath == *".ogg"* ]] && EXT="ogg" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".m4a"* ]] && EXT="m4a" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".mp3"* ]] && EXT="mp3" && mpath2=$(echo $mpath | sed 's/.mp3//') && mpath=$mpath2
mpath2=$(echo ${mpath# $musicpath})
mpath="/$mpath2"
#yad --text="the songpath is =$mpath="
IFS=/ read -a foo <<< $mpath
artist="${foo[1]}"
album="${foo[2]}"
song="${foo[3]}"
	ITEM=$(yad --title="Start a New Playlist" --geometry=400x50 --center --always-print-result --form --field="name of new playlist:" "${song}" )
	output=`echo $?`; [[ $output = "1" ]] && exit
	ITEM2=`echo ${ITEM%%|*}`
	ITEM=$ITEM2
	#
	newPL="${musicpath}/${ITEM}.m3u"
	[ -f "$newPL" ] && 	yad --text="=$newPL= already exists" --timeout=2
	[ -f "$newPL" ] && 	exit
	echo "${artist}/${album}/${song}.${EXT}" > "$newPL"
	wmctrl -c "Track Info"
}
export -f addnewplaylist
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function newalbumart () {
yad --text="just delete the current art, then click 'Track Info' on Yad Player" --on-top --center --timeout=2 &
openfolder
}
export -f newalbumart
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function openfolder () {
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing //p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
IFS=/ read -a foo <<< "$mpath"
artist="${foo[0]}"; 
album="${foo[1]}";#yad --text="artist =$artist=, album =$album="
artpath="""${musicpath}/${artist}/${album}"""
# next: test if last character is "/", if not, put it there
lastc=$(echo "${artpath: -1}")
[[ ! $lastc = "/" ]] && echo yes && artpath2="${artpath}/" && artpath=$artpath2
CMD="""thunar \"${artpath}\" || xdg-open \"${artpath}\" """
#echo $CMD | yad --text-info --editable --timeout=1
eval "$CMD"
}
export -f openfolder
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function openfolder2 () {
xdg-open "${SCRIPTFOLDER}" 
}
export -f openfolder2
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function playalbum () {
	mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing //p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
	mpathshort=${mpath#"$musicpath/"}
IFS=/ read -a foo <<< "$mpathshort"
artist="${foo[0]}";album="${foo[1]}"
pkill mplayer 
wmctrl -c "Track Info" 
	wmctrl -c "Yad Player"
	sleep .3

bash "${SCRIPTPATH}" "ALBUM|$artist/$album" &
}
export -f playalbum
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function playartist () {
	mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing //p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
	mpathshort=${mpath#"$musicpath/"}
IFS=/ read -a foo <<< "$mpathshort"
artist="${foo[0]}";album="${foo[1]}"
pkill mplayer 
	wmctrl -c "Yad Player"
	sleep .3
wmctrl -c "Track Info" 

bash "${SCRIPTPATH}" "ARTIST|$artist/$album" &
}
export -f playartist
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

function reorganize () {
wmctrl -c "Track Info" 
	EXT="mp3"
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1 | sed 's/^ //g')
mpathOLD=$mpath
[[ $mpath == *".ogg"* ]] && EXT="ogg" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".m4a"* ]] && EXT="m4a" && mpath2=$(echo $mpath | sed 's/.m4a//') && mpath=$mpath2
[[ $mpath == *".mp3"* ]] && EXT="mp3" && mpath2=$(echo $mpath | sed 's/.mp3//') && mpath=$mpath2
mpath2=$(echo ${mpath# $musicpath})
mpath="/$mpath2"
#yad --text="the songpath is =$mpath="
IFS=/ read -a foo <<< $mpath
artist="${foo[1]}"
album="${foo[2]}"
song="${foo[3]}"
#yad --text="the songpath is =$mpath=, song=$song, artist=$artist, album=$album"
				function findsong() {
					song="$@"
				#xdg-open "https://musicbrainz.org/search?query=${song}&type=recording&method=indexed" &
				xdg-open "https://www.google.com/search?q=album ${song}" &
				}
				export -f findsong


	ITEM=$(yad --title="Reorganize this Song" --on-top --center --width=500 --auto-kill --form  --field="Song title" --field="Album" --field="Artist name" "$song" "$album" "$artist")
	output=`echo $?`; [[ $output = "1" ]] && exit
	#echo $ITEM | yad --text-info --editable
	#output=`echo $?`; [[ $output = "1" ]] && exit
		
		IFS='|' read -ra details <<< "$ITEM"
		for i in "${details[@]}"; do
		song=$(echo "${details[0]}" | xargs); # gets rid of leading and trailing whitespace
		album=$(echo "${details[1]}" | xargs)
		artist=$(echo "${details[2]}" | xargs)
		done

findsong "${song}, ${artist}"

		IFS='|' read -ra details <<< "$ITEM"
		for i in "${details[@]}"; do
		song=$(echo "${details[0]}" | xargs); # gets rid of leading and trailing whitespace
		album=$(echo "${details[1]}" | xargs)
		artist=$(echo "${details[2]}" | xargs)
		done

 	ITEM=$(yad --title="Reorganize this Song" --on-top --center --width=500  --auto-kill --form  --field="Song title" --field="Album" --field="Artist name" "$song" "$album" "$artist")
	output=`echo $?`; [[ $output = "1" ]] && exit
	
		IFS='|' read -ra details <<< "$ITEM"
		for i in "${details[@]}"; do
		song=$(echo "${details[0]}" | xargs); # gets rid of leading and trailing whitespace
		album=$(echo "${details[1]}" | xargs)
		artist=$(echo "${details[2]}" | xargs)
		done
#yad --text="OLD: $mpathOLD
#NEW: ${artist}/${album}/${song}.$EXT
#
#click OK to make the change, cancel to skip"	
#output=`echo $?`; [[ $output = "1" ]] && exit

# mpathOLD is the path of the old song before editing
CMD="mv \"$musicpath/$mpathOLD\" \"$musicpath/${mpathOLD%/*}/${song}.$EXT\""
#echo "$CMD" | yad --text-info
#output=`echo $?`; [[ $output = "1" ]] && exit
eval "$CMD" ;# that renames the file
mkdir -p "$musicpath/$artist/$album"
mv "$musicpath/${mpathOLD%/*}/${song}.$EXT" "$musicpath/$artist/$album"
# *** todo: make it check first for capitalization variations and playlist entries
# yad --text="$ITEM!!"
}
export -f reorganize
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function showlist () {
wmctrl -c "Track Info" 

yad --text-info --wrap --center --title="${currentList}" --geometry=650x700 --editable --filename="${musicpath}/${currentList}.m3u" > /tmp/editedlist.txt
ans=$?
# 1=cancel, 0=ok
[[ $ans = "0" ]] && yad --text="are you sure?" --center && cp /tmp/editedlist.txt "${musicpath}/${currentList}.m3u"
}
export -f showlist
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function extsong () {
EXT="mp3"
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
[[ $mpath == *".ogg"* ]] && EXT="ogg" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".m4a"* ]] && EXT="m4a" && mpath2=$(echo $mpath | sed 's/.m4a//') && mpath=$mpath2
[[ $mpath == *".mp3"* ]] && EXT="mp3" && mpath2=$(echo $mpath | sed 's/.mp3//') && mpath=$mpath2
# this time keep mpath as absolute path
bash -c 'echo pause > ~/.mplayer/fifo' && TTL=get_meta_title &
#yad --text="${musicpath}/${mpath2}"
song="${musicpath}/${mpath}.$EXT";#yad --text="=$song=" &
audacious "$song" || clementine "$song" ||  banshee "$song" || vlc "$song" || amarok "$song" || rhythmbox "$song" || qmmp "$song" || lollypop "$song" || cantata  "$song" || xdg-open "$song" &
wmctrl -c "Track Info"
}
export -f extsong
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function extlist () {
bash -c 'echo pause > ~/.mplayer/fifo' && TTL=get_meta_title &
wmctrl -c "Track Info" 
song="${musicpath}/${currentList}.m3u"
audacious "$song" || clementine "$song" ||  banshee "$song" || vlc "$song" || amarok "$song" || rhythmbox "$song" || qmmp "$song" || lollypop "$song" || cantata  "$song" &
}
export -f extlist
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function boostvol () {
EXT="mp3"
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/' | tail -1)
[[ $mpath == *".ogg"* ]] && EXT="ogg" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".m4a"* ]] && EXT="m4a" && mpath2=$(echo $mpath | sed 's/.ogg//') && mpath=$mpath2
[[ $mpath == *".mp3"* ]] && EXT="mp3" && mpath2=$(echo $mpath | sed 's/.mp3//') && mpath=$mpath2
# this time keep mpath as absolute path
song="${musicpath}/${mpath2}.$EXT"
yad --text="about to create a louder version of ${song}" --center --timeout=2 &
song2="${musicpath}/${mpath2}.L.$EXT"
ffmpeg -i "$song" -filter:a "volume=2" "$song2"
echo "$song2" > /tmp/volumeboosted
cat "${musicpath}/${currentList}.m3u" >> /tmp/volumeboosted
cp /tmp/volumeboosted ${musicpath}/${currentList}.m3u 
$SCRIPTPATH "$currentlist"
}
export -f boostvol
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF



 COUNTER=0
         while [  $COUNTER -lt $numitems ]; do
   CMD2b="--field \"${aLists[$COUNTER]}:BTN\" "
   CMD2="${CMD2} ${CMD2b}"

   CMD3b="\"bash -c 'onClick \${aLists[$COUNTER]}'\" "
   CMD3="${CMD3} ${CMD3b}"
   let COUNTER=COUNTER+1 
         done
	CMD="${CMD1}${CMD2}${CMD3}"
#	echo "command is 
#	$CMD	"
	eval "$CMD &"

MYOUT=$(yad --title="Controls"  --plug=$KEY --tabnum=3   --form --columns=2 \
 --field "New Playlist:BTN" \
 --field "Redo Album Art:BTN" \
 --field "Open SONG Folder:BTN" \
 --field "Open Script Folder:BTN" \
 --field "Play this Album:BTN" \
 --field "Play this Artist:BTN" \
 --field "Search for Music:BTN" \
 --field "Reorganize this:BTN" \
 --field "Edit this Playlist:BTN" \
 --field "play SONG externally:BTN" \
 --field "play LIST externally:BTN" \
 --field "Boost Track Volume:BTN" \
"bash -c 'addnewplaylist'" \
"bash -c 'newalbumart'" \
"bash -c 'openfolder'" \
"bash -c 'openfolder2'" \
"bash -c 'playalbum'" \
"bash -c 'playartist'" \
"bash -c 'search'" \
"bash -c 'reorganize'" \
"bash -c 'showlist'" \
"bash -c 'extsong'" \
"bash -c 'extlist'" \
"bash -c 'boostvol'") &

########################## END controls tab 3 ######################





#                                                                                                                 
#  888888888888         88                      ,d8                                                               
#       88              88                    ,d888                                  ,d                           
#       88              88                  ,d8" 88                                  88                           
#       88  ,adPPYYba,  88,dPPYba,        ,d8"   88       8b,dPPYba,    ,adPPYba,  MM88MMM  ,adPPYba,  ,adPPYba,  
#       88  ""     `Y8  88P'    "8a     ,d8"     88       88P'   `"8a  a8"     "8a   88    a8P_____88  I8[    ""  
#       88  ,adPPPPP88  88       d8     8888888888888     88       88  8b       d8   88    8PP"""""""   `"Y8ba,   
#       88  88,    ,88  88b,   ,a8"              88       88       88  "8a,   ,a8"   88,   "8b,   ,aa  aa    ]8I  
#       88  `"8bbdP"Y8  8Y"Ybbd8"'               88       88       88   `"YbbdP"'    "Y888  `"Ybbd8"'  `"YbbdP"'  
#                                                                                                                 
#                                                                                                                 
                                                                                                                 
                                                     
              


############################## misc tab  #########################
misc="Todo: 

able to list artists or albums, checkbox, add to playlist
get/update song info (using id3tool?)
volume controls
replay previous song(s)

Note!! this script will resize your album art if its too big

Also, I think the playlist add/remove feature only works if
the playlists are in the home/user/someFolder directory structure"

#yad --text-info --wrap --center --title="${currentList}" --geometry=650x700 --editable --filename=${musicpath}/${currentList}.m3u > /tmp/editedlist.txt
#ans=$?
# 1=cancel, 0=ok
#[[ $ans = "0" ]] && yad --text="are you sure?" --center && cp /tmp/editedlist.txt ${musicpath}/${currentList}.m3u

yad --plug=$KEY --tabnum=4 --text-info --wrap --center --editable --title="Notes" --filename=${SCRIPTFOLDER}/TODOs.txt > /tmp/ypNotes.txt &



#                                                                                                  
#  888888888888                                 88            88                 ad88              
#       88                                      88            88                d8"                
#       88                                      88            88                88                 
#       88  8b,dPPYba,  ,adPPYYba,   ,adPPYba,  88   ,d8      88  8b,dPPYba,  MM88MMM  ,adPPYba,   
#       88  88P'   "Y8  ""     `Y8  a8"     ""  88 ,a8"       88  88P'   `"8a   88    a8"     "8a  
#       88  88          ,adPPPPP88  8b          8888[         88  88       88   88    8b       d8  
#       88  88          88,    ,88  "8a,   ,aa  88`"Yba,      88  88       88   88    "8a,   ,a8"  
#       88  88          `"8bbdP"Y8   `"Ybbd8"'  88   `Y8a     88  88       88   88     `"YbbdP"'   
#                                                                                                  
#                                                                                                  
                                                                           

wmctrl -c "Track Info"
yad --notebook --key=$KEY --selectable-labels --tab=$"Art" --tab=$"Toggle Playlists" --tab=$"Controls" --tab=$"Notes"  \
    --title=$"Track Info"  \
    --width=600 --height=500 --image-on-top --timeout=60 --center --button="-:amixer -q sset Master 7%- || amixer -q -D pulse sset Master 7%-" --button="+:amixer -q sset Master 7%+ || amixer -q -D pulse sset Master 7%+" --button="yad-close:0"
ans=$?
# 1=cancel, 0=ok
[[ $ans = "0" ]] && cp /tmp/ypNotes.txt ${SCRIPTFOLDER}/TODOs.txt

}
export -f trackinfo

#                                                                                                                                                    
#                                    88              ad88888ba   88                                                     88           88              
#                                    88             d8"     "8b  88                                              ,d     ""    ,d     88              
#                                    88             Y8,          88                                              88           88     88              
#   ,adPPYba,  8b,dPPYba,    ,adPPYb,88  888        `Y8aaaaa,    88,dPPYba,    ,adPPYba,   8b      db      d8  MM88MMM  88  MM88MMM  88   ,adPPYba,  
#  a8P_____88  88P'   `"8a  a8"    `Y88  888          `"""""8b,  88P'    "8a  a8"     "8a  `8b    d88b    d8'    88     88    88     88  a8P_____88  
#  8PP"""""""  88       88  8b       88                     `8b  88       88  8b       d8   `8b  d8'`8b  d8'     88     88    88     88  8PP"""""""  
#  "8b,   ,aa  88       88  "8a,   ,d88  888        Y8a     a8P  88       88  "8a,   ,a8"    `8bd8'  `8bd8'      88,    88    88,    88  "8b,   ,aa  
#   `"Ybbd8"'  88       88   `"8bbdP"Y8  888         "Y88888P"   88       88   `"YbbdP"'       YP      YP        "Y888  88    "Y888  88   `"Ybbd8"'  
#                                                                                                                                                    
# 














# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function closelast () {
	wmctrl -c "Track Info" &
}
export -f closelast
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function bottomleft () {
	sleep .5
windowId=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Yad Player')

xdotool windowactivate ${windowId} 

IFS='x' read sw sh < <(xdpyinfo | grep dimensions | grep -o '[0-9x]*' | head -n1)
#x=`echo "$sw/25" | bc`; # for left corner
x=`echo "$sw/1.2" | bc`
y=`echo "$sh/1.4" | bc`
w=`echo "$sw/9" | bc`
h=`echo "$sh/9" | bc`

# this says bottomleft but right now its bottom Right
xdotool windowmove ${windowId} ${x} ${y}
xdotool windowsize ${windowId} 254 ${h}
}
export -f bottomleft
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

#                                                             
#  88b           d88                          88              
#  888b         d888                          ""              
#  88`8b       d8'88                                          
#  88 `8b     d8' 88  88       88  ,adPPYba,  88   ,adPPYba,  
#  88  `8b   d8'  88  88       88  I8[    ""  88  a8"     ""  
#  88   `8b d8'   88  88       88   `"Y8ba,   88  8b          
#  88    `888'    88  "8a,   ,a88  aa    ]8I  88  "8a,   ,aa  
#  88     `8'     88   `"YbbdP'Y8  `"YbbdP"'  88   `"Ybbd8"'  
#                                                             
#                                                             

# make 0.recentSongs.m3u
#find -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) -printf '%T@ %c %p\n' | sort -r -k 1 -n | tr -s ' ' | cut -d' ' -f7- | sed 's/\.\///' | head -n 300 > 0.recentSongs.m3u 
# 2021-09-27 not quite right

cd ${musicpath}
shuffle=1

if [ -z "$startinglist" ]
then
		echo no starting list provided, start with all
	  startinglist="0.allSongs"
      find -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | sed 's/\.\///' > 0.allSongs.m3u
      mplayer -vo null -slave -quiet -shuffle -playlist "${startinglist}.m3u" > /tmp/mplayerlog &
      #yad --text="=$startinglist="
else
		echo startinglist is =${startinglist}=
		
		
if [[ $startinglist = "searchPlaylist" ]]; then shuffle=0
fi		
		
		
	if	[[ $startinglist == *"ARTIST|"* ]]; then
#> artist.m3u
	 startinglist2=$(echo $startinglist | sed 's/ARTIST|//')
	 #yad --text="=${musicpath}/${startinglist2}/="
	 cd "${musicpath}/${startinglist2}/"
	 #function prepend() { while read line; do echo "${1}${line}"; done; }
	find "$(cd ..; pwd)" -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | rev | cut -d'/' -f-3 | rev > "${musicpath}/artist.m3u"
	 startinglist="artist"
	 #cat "${musicpath}/artist.m3u" | yad --text-info
	 cd "${musicpath}"
	 fi
	 
	 
	 	if	[[ $startinglist == *"ALBUM|"* ]]; then
	#> album.m3u
	shuffle=0
	 startinglist2=$(echo $startinglist | sed 's/ALBUM|//')
	 #yad --text="=${musicpath}/${startinglist2}/="
	 cd "${musicpath}/${startinglist2}/"
	 #function prepend() { while read line; do echo "${1}${line}"; done; }
	find "$(cd .; pwd)" -type f \( -iname \*.mp3 -o -iname \*.m4a -o -iname \*.ogg \) | rev | cut -d'/' -f-3 | rev | sort --version-sort > "${musicpath}/album.m3u"
	 startinglist="album"
	 #cat "${musicpath}/album.m3u" | yad --text-info
	 cd "${musicpath}"
	 fi
	 
	 
	 [[ $shuffle == "1" ]] && mplayer -vo null -slave -quiet -shuffle -playlist "${startinglist}.m3u" > /tmp/mplayerlog &
	 [[ $shuffle == "0" ]] && mplayer -vo null -slave -quiet -playlist "${startinglist}.m3u" > /tmp/mplayerlog &
	  
	 # bash $SCRIPTPATH &
fi




sleep 2
export currentList="${startinglist}"
trackinfo &


#                                                                                         
#  88b           d88              88                  8b        d8                    88  
#  888b         d888              ""                   Y8,    ,8P                     88  
#  88`8b       d8'88                                    Y8,  ,8P                      88  
#  88 `8b     d8' 88  ,adPPYYba,  88  8b,dPPYba,         "8aa8"  ,adPPYYba,   ,adPPYb,88  
#  88  `8b   d8'  88  ""     `Y8  88  88P'   `"8a         `88'   ""     `Y8  a8"    `Y88  
#  88   `8b d8'   88  ,adPPPPP88  88  88       88          88    ,adPPPPP88  8b       88  
#  88    `888'    88  88,    ,88  88  88       88          88    88,    ,88  "8a,   ,d88  
#  88     `8'     88  `"8bbdP"Y8  88  88       88          88    `"8bbdP"Y8   `"8bbdP"Y8  
#                                                                                         
#     
############################ play new playlist ########################
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function playplaylist () {
	cd "$musicpath"
	wmctrl -c "Track Info"
	CMD1="yad --title=\"Pick a List to Play\" --center --form --columns=4 "
	CMD2=""
	CMD3=""

	aLists=()
	while IFS= read -r line; do
		aLists+=( "$line" )
	done < <( ls *.m3u )
		numitems=$(echo "${#aLists[@]}")
		
	# fffffffffffffffffffffffffffffffffffffffffffff
	# fffffffffffffffffffffffffffffffffffffffffffff
function onClick () {
	wmctrl -c "Yad Player"
	#sleep 1
	plist=$(echo "$@")
mylist=$(echo ${plist} | sed 's/\.m3u//')
pkill mplayer 
wmctrl -c "Track Info" 
wmctrl -c "Pick a List to Play" 

# remove any invisible null characters (\0) in the playlist first:
#sed -i s/\\0//g $musicpath/$mylist.m3u
#sleep 1
bash "${SCRIPTPATH}" "$mylist" &
}
export -f onClick
	# fffffffffffffffffffffffffffffffffffffffffffff
	# fffffffffffffffffffffffffffffffffffffffffffff
 COUNTER=0
         while [  $COUNTER -lt $numitems ]; do
   CMD2b="--field \"${aLists[$COUNTER]}:BTN\" "
   CMD2="${CMD2} ${CMD2b}"

   CMD3b="\"bash -c 'onClick \${aLists[$COUNTER]}'\" "
   CMD3="${CMD3} ${CMD3b}"
   let COUNTER=COUNTER+1 
         done
	CMD="${CMD1}${CMD2}${CMD3}"
#	echo "command is 
#	$CMD	"
	eval "$CMD &"
}
export -f playplaylist
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
################################# end playplaylist ####################
function minimize () {
ID=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Yad Player')
xdotool windowminimize $ID
}
export -f minimize
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function quieter () {
amixer -q sset Master 7%- || amixer -q -D pulse sset Master 7%-
}
export -f quieter
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function louder () {
amixer -q sset Master 7%+ || amixer -q -D pulse sset Master 7%+
}
export -f louder
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function close () {
ID=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Yad Player')
pkill mplayer
xdotool windowclose $ID
sleep 1 && pkill mplayer
ID=$(xdotool search --onlyvisible --class 'yad' getwindowpid %@ | xargs -I{} xdotool search --all --pid {} --name 'Track Info')
xdotool windowclose $ID
}
export -f close
# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

# this gets current played songs so far: 
mpath=$(cat /tmp/mplayerlog | sed -n -e 's/^.*Playing//p' | sed 's/.mp3.*/.mp3/' | sed 's/.ogg.*/.ogg/' | sed 's/.m4a.*/.m4a/'| tail -1)
IFS=/ read -a foo <<< $mpath
artist=${foo[0]}
album=${foo[1]}
song=${foo[2]}

# former geometry: --geometry=170x100+50+500
bottomleft &
# the following is to ensure that if you close the little player window 
# mplayer won't keep playing
bash $SCRIPTFOLDER/mplayerKill.sh &
#yad --text="=$SCRIPTFOLDER="

MYOUT=$(yad --title="Yad Player" --no-buttons --geometry=255x50 --window-icon="${SCRIPTFOLDER}/music2.png" --auto-kill --form --columns=2 \
 --field "Pause/Play:BTN" \
 --field "Next Song:BTN" \
 --field="Minimize:BTN" \
 --field="-:BTN" \
 --field "Track Info:BTN" \
 --field "Choose Playlist:BTN" \
 --field="Search:BTN" \
 --field="+:BTN" \
"bash -c 'echo pause > ~/.mplayer/fifo' && TTL=get_meta_title" \
"bash -c 'echo pt_step 1 pause  > ~/.mplayer/fifo && closelast && sleep .7 && trackinfo'" \
"bash -c minimize" \
"bash -c quieter" \
"bash -c 'closelast && sleep .5 && trackinfo'" \
"bash -c playplaylist" \
"bash -c search" \
"bash -c louder" )

# --button="-:amixer -q sset Master 7%- || amixer -q -D pulse sset Master 7%-" <-- works
# "bash -c 'amixer -q sset Master 7%- || amixer -q -D pulse sset Master 7%-'" 

# 'bash -c "amixer -q sset Master 7%+ || amixer -q -D pulse sset Master 7%+"'
# "bash -c 'amixer -q sset Master 7%+ || amixer -q -D pulse sset Master 7%+'"

#  --button="-:amixer -q sset Master 7%- || amixer -q -D pulse sset Master 7%-" --button="+:amixer -q sset Master 7%+ || amixer -q -D pulse sset Master 7%+"

outpt=$?

 #[ $outpt = "0" ] && yad --text="you clicked okay, not cancel"

 #[ $outpt = "1" ] && pkill mplayer && bash $SCRIPTFOLDER/mplayerKill.sh &
 #[ $outpt = "1" ] && pkill mplayer && exit
 #[ $outpt = "0" ] && ID=$(xdotool search --name "Yad Player")
 #[ $outpt = "0" ] && xdotool windowminimize $ID
 #echo the output is $MYOUT
 
 ################  Fifo commands (there's more)
 # toggle pause:
#echo pause > ~/.mplayer/fifo

# plays the next one in the list
## echo pt_step 1  > ~/.mplayer/fifo
#plays the previous one in the list (but not if its shuffled) <- that's why should switch to externally shuffling lists
##echo pt_step -1  > ~/.mplayer/fifo
